public class bus
{
    static Gain @ chan[4];
}
new Gain[4] @=> bus.chan;

//CIP v1

//add patch_publicclass.ck and buss_publicclass.ck to VM

//basic audio routing
adc => bus.chan[0] => blackhole;
bus.chan[3] => dac;


//GUI interface
//labels for sliders
["0","1","2","3","4","5","6","7"] @=> string label[];

MAUI_View bus_view;
bus_view.size( 250, 500 );

MAUI_Gauge gauge[4];
MAUI_Slider slider[4];

//setup gauge
function void lev_mon (int a){
    while (true){
        bus.chan[a].last() * 100.0 => gauge[a].value;
        20::ms => now;
    }
}

//await slider movment
function void slid_event (int b){
    while (true){
        slider[b] => now;
        slider[b].value() => bus.chan[b].gain;
    }
}

//setup interface for each bus
for(0 => int i; i < 4; i++ ){
    bus_view.addElement (gauge[i]);
    gauge[i].position(0,(i * 60));
    bus_view.addElement (slider[i]);
    label[i] => slider[i].name;
    slider[i].position(0,(i * 60));
    spork ~ lev_mon(i);
    spork ~ slid_event(i);
    0 => bus.chan[i].gain;
}

//draw display    
bus_view.display();

while(true) {
    1::hour => now;
}